#!/usr/bin/perl
#
# (C) 2001-2002
#	Domsodi Gergely	<doome@uhulinux.hu>
#	Pozsar Balazs	<pozsy@uhulinux.hu>
#
# This file is originally part of the UHU Linux distribution.
# Distributable under GPL v2.
#

# ----- Pragmatic modules -----------------------------------------------------
use strict;
use warnings;

# -----------------------------------------------------------------------------
package UHU::detect;

use UHU::common;

# ----- Exporter --------------------------------------------------------------
require Exporter;
our @ISA    = qw(Exporter);
our @EXPORT = qw(
_capacity
disks
);

# ----- General helper subs ---------------------------------------------------
sub _model($) {
	my ($device) = @_;

	_chomp(`getmodel $device`) or "Ismeretlen";
}

sub _capacity($) {
	my ($device) = @_;

	((_chomp(`blockdev --getsize $device`) or 0) *
		(_chomp(`blockdev --getss $device`) or 512));
}

sub _realpath($) {
	my ($device) = @_;

	_chomp(`readlink -f $device`) or "";
}

sub disks() {
	my $size;
	my @tmp;
	return ((map {
		s|^/dev/||;
		(-e "/dev/cdroms/$_") ? () : {
			model      => _model "/dev/$_",
			capacity   => _capacity "/dev/$_",
			device     => "/dev/$_",
			partitions => [
				map {{
					size   => _capacity $_,
					device => _realpath $_,
				}} (< /dev/$_?* >),
			]
		}
	} (< /dev/[hs]d[a-z] >)),
	(( @tmp = map { 
		($size = (`blockdev --getsize $_` * 512)) ? {
			size   => $size,
			device => $_,
		} : ()
	} (< /dev/md[0-9]+ >) ) ?
	{
			model      => "RAID",
			capacity   => undef,
			device     => undef,
			partitions => [ @tmp ],
	} : () ));
}

# ----- Beatiful perl :) ------------------------------------------------------
"Mit mond a sundiszno a surolokefen?";
